import java.io.*;
import java.util.*;
import javax.microedition.rms.*;
import javax.microedition.lcdui.*;


public class QuickScreen extends Form implements CommandListener {
    private static Vector list;

    private Command send=new Command("",Command.OK,1), back=new Command("",Command.CANCEL,2), add=new Command("",Command.SCREEN,3), del=new Command("",Command.SCREEN,3);
    private ChoiceGroup cg;
    private Virca v;
    private String reply;
    private QuickInput qi;

    public QuickScreen(Virca v) {
        super("");
        setCommandListener(this);
        addCommand(send);
        addCommand(back);
        addCommand(add);
        addCommand(del);
        this.v=v;
        
        cg=new ChoiceGroup("",Choice.MULTIPLE);
        append(cg);
        updateList();
    }
    public ChoiceGroup getChoiceGroup() { return cg; }
    public String getReply() { return reply; }
    public void setReply(String s) { reply=s; }

    public void updateList() {
        while(cg.size()>0) cg.delete(0);
        for(int i=0; i<list.size(); i++)
            cg.append((String)list.elementAt(i),null);
    }
    
    public void reset() {
       boolean[] b=new boolean[cg.size()];
       cg.setSelectedFlags(b);
       b=null;
       System.gc();
    }
    protected void deleteSelected() {
        boolean[] b=new boolean[cg.size()];
        cg.getSelectedFlags(b);
        for(int i=b.length-1; i>=0; i--) {
            if(b[i]==true) list.removeElementAt(i);
        }
        updateList();
        save();
    }
    public void inputCompleted(boolean b) {
        if(b) {
            //I'm lazy:
            list.addElement(qi.getBox().getString());
            sort();
            updateList(); 
            save();
        }
        qi=null;
        System.gc();
        v.display(this);
    }
    public void commandAction(Command c, Displayable d) {
        if(c==back || c==send) v.quickCompleted(c==send);
        else if(c==add) {
            qi=new QuickInput(this);
            v.display(qi.getBox());
        } else if(c==del) {
            deleteSelected();
        }
    }
    
    public static void load() {
        list=new Vector();
        try {
            RecordStore rs=RecordStore.openRecordStore("",false);
            RecordEnumeration re=rs.enumerateRecords(null,null,false);
            while(re.hasNextElement()) {
                byte[] b=re.nextRecord();
                System.gc();
                DataInputStream dis=
                    new DataInputStream(new ByteArrayInputStream(b));
                int n=dis.readInt();
                for(int i=0; i<n; i++) 
                    list.addElement(dis.readUTF());
                dis.close();
            }
            rs.closeRecordStore();
        } catch(Exception e) {
            e.printStackTrace();
        }
        sort();
    }
    public static void sort() {
        String s;
        for(int i=0; i<list.size(); i++)
            for(int j=i; j<list.size(); j++) 
                if(((String)list.elementAt(j)).compareTo((String)list.elementAt(i))<0) {
                    s=(String)list.elementAt(i);
                    list.setElementAt(list.elementAt(j),i);
                    list.setElementAt(s,j);
                }
    }
    
    public static void save() {
        ByteArrayOutputStream baos=new ByteArrayOutputStream();
        DataOutputStream dos=new DataOutputStream(baos);
        try {
            dos.writeInt(list.size());
            for(int i=0; i<list.size(); i++)
                dos.writeUTF((String)list.elementAt(i));
            dos.close();
            baos.close();
            try {
                RecordStore.deleteRecordStore("");
            } catch(Exception e) {}
            RecordStore rs=RecordStore.openRecordStore("",true);
            byte[] b=baos.toByteArray();
            rs.addRecord(b,0,b.length);
            b=null;
            rs.closeRecordStore();
        } catch(Exception e) {
            e.printStackTrace();
        }
    }
}

class QuickInput implements CommandListener {
    private QuickScreen qs;
    private TextBox tb;
    private Command ok=new Command("Ok!",Command.OK,1), cancel=new Command("",Command.CANCEL,2);
    
    public QuickInput(QuickScreen q) {
        qs=q;
        tb=new TextBox(" ","",128,TextField.ANY);
        tb.setCommandListener(this);
        tb.addCommand(ok);
        tb.addCommand(cancel);
    }
    public void reset() { tb.setString(""); }
    public TextBox getBox() { return tb; }
    public void commandAction(Command c, Displayable d) {
        qs.inputCompleted(c==ok);
    }
}

